////////////////////////////////////////////////////////////////////////
// putchat.cpp
// generated with ecppc
// date: Sat Jan 19 17:27:22 2008
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/objecttemplate.h>
#include <tnt/objectptr.h>
#include <tnt/comploader.h>
#include <tnt/tntconfig.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.putchat")

// <%pre>
#line 1 "global.ecpp"


#include <list>
#include <string>

struct chatMessage
{
  chatMessage() { }
  chatMessage(const std::string& person_, const std::string& message_)
    : person(person_),
      message(message_)
      { }

  std::string person;
  std::string message;
};

typedef std::list<chatMessage> chat_type;


#line 6 "putchat.ecpp"


std::string replaceImg(std::string message, const std::string& txt,
  const std::string& repl)
{
  std::string::size_type n = 0;
  while ((n = message.find(txt, n)) != std::string::npos)
  {
    message.replace(n, txt.size(), repl);
    n += repl.size() - txt.size();
  }

  return message;
}


// </%pre>

namespace
{
template <typename T> inline void use(const T&) { }

class putchat : public tnt::EcppComponent
{
    putchat& main()  { return *this; }

  protected:
    ~putchat();

  public:
    putchat(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam);
    // <%config>
    static unsigned maxComments;
    // </%config>

};

class putchatFactory : public tnt::ComponentFactoryImpl<putchat>
{
  public:
    putchatFactory()
      : tnt::ComponentFactoryImpl<putchat>("putchat")
      { }
    tnt::Component* doCreate(const tnt::Compident& ci,
      const tnt::Urlmapper& um, tnt::Comploader& cl);
    virtual void doConfigure(const tnt::Tntconfig& config);
};

tnt::Component* putchatFactory::doCreate(const tnt::Compident& ci,
  const tnt::Urlmapper& um, tnt::Comploader& cl)
{
  return new putchat(ci, um, cl);
}

void putchatFactory::doConfigure(const tnt::Tntconfig& config)
{
  // <%config>
    if (config.hasValue("maxComments"))
      putchat::maxComments = tnt::stringTo<unsigned>( config.getValue("maxComments") );
  // </%config>
}

static putchatFactory factory;

static const char* rawData = "\010\000\000\000\t\000\000\000\n";

// <%shared>
// </%shared>

bool config_init = false;
// <%config>
unsigned putchat::maxComments =  10;
// </%config>

putchat::putchat(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

putchat::~putchat()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned putchat::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);

  TNT_APPLICATION_GLOBAL_VAR(chat_type, chat, "chat", ());   // <%application> chat_type chat
  // <%args>
std::string person = qparam.param("person");
std::string message = qparam.param("message");
  // </%args>

  // <%cpp>
  // <%include> global.ecpp
  // </%include>
#line 22 "putchat.ecpp"


  if (!message.empty())
  {
    log_info("new message from " << person << ": \"" << message << '"');

    message = replaceImg(message, ":)", "<img src=\"smile\">");
    message = replaceImg(message, ":(", "<img src=\"sad\">");
    message = replaceImg(message, ";)", "<img src=\"wink\">");

    chat.push_back(chatMessage(person, message));
    if (chat.size() > maxComments)
      chat.erase(chat.begin());
  }


  // <& getchat ...
#line 38 "putchat.ecpp"
  cxxtools::QueryParams _tnt_cq0(qparam, false);
#line 38 "putchat.ecpp"
  callComp(tnt::Compident(std::string(), "getchat"), request, reply, _tnt_cq0);
  // &>
  reply.out() << data[0]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace

