////////////////////////////////////////////////////////////////////////
// session.cpp
// generated with ecppc
// date: Sat Jan 19 17:27:43 2008
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/objecttemplate.h>
#include <tnt/objectptr.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.session")

// <%pre>
// </%pre>

namespace
{
template <typename T> inline void use(const T&) { }

class session : public tnt::EcppComponent
{
    session& main()  { return *this; }

  protected:
    ~session();

  public:
    session(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam);
    class subcomp_type : public tnt::EcppSubComponent
    {
        session& mainComp;
        session& main()  { return mainComp; }

      public:
        subcomp_type(session& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam);
    };

    subcomp_type subcomp;
};

static tnt::ComponentFactoryImpl<session> sessionFactory("session");

static const char* rawData = "P\000\000\000m\000\000\000\220\000\000\000\254\000\000\000\321\000\000\000\361\000\000\000\022\001\000\000.\001\000\000X\001\000\000\267\001\000\000\272\001\000\000\274\001\000\000\276\001\000\000\366\001\000\000\024\002\000\000;\002\000\000]\002\000\000\200\002\000\000\236\002\000\000\244\002\000\000\nSessioncounter (component): <br>\nSessioncounter (application): <br>\nSessioncounter (page): <br>\nApplicationcounter (component): <br>\nApplicationcounter (page): <br>\nRequestcounter (component): <br>\nRequestcounter (page): <br>\n\n<div style=\"background-color:#ffa\">\n\n</div>\n\n<a href=\"session\">reload this</a> -\n<a href=\"appsession\">applicationsession only</a>\n\n\n      \n  <h1>Subcomponent</h1>\n\n  Sessioncounter (component): <br>\n  Sessioncounter (page): <br>\n  Applicationcounter (component): <br>\n  Applicationcounter (page): <br>\n  Requestcounter (component): <br>\n  Requestcounter (page): <br>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

session::session(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    subcomp(*this, "subcomp")
{
  // <%init>
  // </%init>
}

session::~session()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned session::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);

  TNT_SESSION_COMPONENT_VAR(unsigned, s, "s", (0));   // <%session> unsigned s(0)
  TNT_SESSION_GLOBAL_VAR(unsigned, sa, "sa", (0));   // <%session> unsigned sa(0)
  TNT_SESSION_PAGE_VAR(unsigned, sp, "sp", (0));   // <%session> unsigned sp(0)
  TNT_APPLICATION_COMPONENT_VAR(unsigned, a, "a", (0));   // <%application> unsigned a(0)
  TNT_APPLICATION_PAGE_VAR(unsigned, ap, "ap", (0));   // <%application> unsigned ap(0)
  TNT_REQUEST_COMPONENT_VAR(unsigned, r, "r", (0));   // <%request> unsigned r(0)
  TNT_REQUEST_PAGE_VAR(unsigned, rp, "rp", (0));   // <%request> unsigned rp(0)
  // <%args>
  // </%args>

  // <%cpp>
  reply.out() << data[0]; // \nSessioncounter (component): 
#line 37 "session.ecpp"
  reply.sout() << ( ++s );
  reply.out() << data[1]; // <br>\nSessioncounter (application): 
#line 38 "session.ecpp"
  reply.sout() << ( ++sa );
  reply.out() << data[2]; // <br>\nSessioncounter (page): 
#line 39 "session.ecpp"
  reply.sout() << ( ++sp );
  reply.out() << data[3]; // <br>\nApplicationcounter (component): 
#line 40 "session.ecpp"
  reply.sout() << ( ++a );
  reply.out() << data[4]; // <br>\nApplicationcounter (page): 
#line 41 "session.ecpp"
  reply.sout() << ( ++ap );
  reply.out() << data[5]; // <br>\nRequestcounter (component): 
#line 42 "session.ecpp"
  reply.sout() << ( ++r );
  reply.out() << data[6]; // <br>\nRequestcounter (page): 
#line 43 "session.ecpp"
  reply.sout() << ( ++rp );
  reply.out() << data[7]; // <br>\n\n<div style="background-color:#ffa">\n
  // <& subcomp ...
#line 46 "session.ecpp"
  cxxtools::QueryParams _tnt_cq0(qparam, false);
#line 46 "session.ecpp"
  main().subcomp(request, reply, _tnt_cq0);
  // &>
  reply.out() << data[8]; // \n</div>\n\n<a href="session">reload this</a> -\n<a href="appsession">applicationsession only</a>\n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned session::subcomp_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);
  TNT_SESSION_COMPONENT_VAR(unsigned, s, "s", (0));   // <%session> unsigned s(0)
  TNT_APPLICATION_COMPONENT_VAR(unsigned, a, "a", (0));   // <%application> unsigned a(0)
  TNT_REQUEST_COMPONENT_VAR(unsigned, r, "r", (0));   // <%request> unsigned r(0)
  TNT_SESSION_PAGE_VAR(unsigned, sp, "sp", (0));   // <%session> unsigned sp(0)
  TNT_APPLICATION_PAGE_VAR(unsigned, ap, "ap", (0));   // <%application> unsigned ap(0)
  TNT_REQUEST_PAGE_VAR(unsigned, rp, "rp", (0));   // <%request> unsigned rp(0)
  TNT_SESSION_GLOBAL_VAR(unsigned, sa, "sa", (0));   // <%session> unsigned sa(0)
  // <%args>
  // </%args>

  // <%cpp>
  reply.out() << data[9]; // \n  
  reply.out() << data[10]; //   
  reply.out() << data[11]; //   
  reply.out() << data[12]; // \n  <h1>Subcomponent</h1>\n\n  Sessioncounter (component): 
#line 72 "session.ecpp"
  reply.sout() << ( ++s );
  reply.out() << data[13]; // <br>\n  Sessioncounter (page): 
#line 73 "session.ecpp"
  reply.sout() << ( ++sp );
  reply.out() << data[14]; // <br>\n  Applicationcounter (component): 
#line 74 "session.ecpp"
  reply.sout() << ( ++a );
  reply.out() << data[15]; // <br>\n  Applicationcounter (page): 
#line 75 "session.ecpp"
  reply.sout() << ( ++ap );
  reply.out() << data[16]; // <br>\n  Requestcounter (component): 
#line 76 "session.ecpp"
  reply.sout() << ( ++r );
  reply.out() << data[17]; // <br>\n  Requestcounter (page): 
#line 77 "session.ecpp"
  reply.sout() << ( ++rp );
  reply.out() << data[18]; // <br>\n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace

