////////////////////////////////////////////////////////////////////////
// strings.cpp
// generated with ecppc
// date: Sat Jan 19 17:27:48 2008
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/objecttemplate.h>
#include <tnt/objectptr.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.strings")

// <%pre>
#line 1 "strings.ecpp"


#include <vector>


// </%pre>

namespace
{
template <typename T> inline void use(const T&) { }

class strings : public tnt::EcppComponent
{
    strings& main()  { return *this; }

  protected:
    ~strings();

  public:
    strings(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<strings> stringsFactory("strings");

static const char* rawData = "\034\000\000\000\231\001\000\000\245\001\000\000\263\001\000\000\327\001\000\000\361\001\000\000\022\002\000\000\n<html>\n <head><title>Example CSP</title></head>\n <body> \n  <h1>Example CSP</h1>\n\n   <p>This servlet enters strings into a table.</p>\n\n   <form method=get> \n    <p>Enter a string:\n    <input type=text size=64 name=\"string\"></input>\n    <input type=submit name=\"add\" value=\"Go!\"></input>\n    </p> \n   </form>\n <p>\n\n <table border=1> \n  <tr>\n   <th colspan=2>Strings entered so far: </th></tr>\n \n <tr> \n  <td></td>\n  <td><a href=\"strings\?remove=\">remove</a></td> \n</tr>\n  \n</table></p> \n</body> \n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

strings::strings(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

strings::~strings()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned strings::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, cxxtools::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);

  TNT_SESSION_COMPONENT_VAR(std::vector<std::string>, strings, "strings", ());   // <%session> std::vector<std::string> strings
  // <%args>
std::string add = qparam.param("add");
std::string string = qparam.param("string");
unsigned remove = qparam.has("remove") ? tnt::stringToWithDefaultConverter<unsigned>( 9999, reply.out().getloc())(qparam.param("remove")) :  9999;
  // </%args>

  // <%cpp>
#line 14 "strings.ecpp"


  if (!add.empty())
    strings.push_back(string);

  if (remove != 9999)
    strings.erase(strings.begin() + remove);


  reply.out() << data[0]; // \n<html>\n <head><title>Example CSP</title></head>\n <body> \n  <h1>Example CSP</h1>\n\n   <p>This servlet enters strings into a table.</p>\n\n   <form method=get> \n    <p>Enter a string:\n    <input type=text size=64 name="string"></input>\n    <input type=submit name="add" value="Go!"></input>\n    </p> \n   </form>\n <p>\n\n <table border=1> \n  <tr>\n   <th colspan=2>Strings entered so far: 
#line 40 "strings.ecpp"
  reply.sout() << (strings.size());
  reply.out() << data[1]; // </th></tr>\n 
#line 41 "strings.ecpp"
 
   for (std::vector<std::string>::const_iterator i = strings.begin();
        i != strings.end(); ++i) { 
  
  reply.out() << data[2]; // \n <tr> \n  <td>
#line 46 "strings.ecpp"
  reply.sout() << ( *i );
  reply.out() << data[3]; // </td>\n  <td><a href="strings\?remove=
#line 47 "strings.ecpp"
  reply.sout() << (i - strings.begin());
  reply.out() << data[4]; // ">remove</a></td> \n</tr>\n 
#line 49 "strings.ecpp"
 
} 

  reply.out() << data[5]; //  \n</table></p> \n</body> \n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace

